summaryrefslogtreecommitdiff
path: root/tests/pcre-invalid-utf8-input
diff options
context:
space:
mode:
Diffstat (limited to 'tests/pcre-invalid-utf8-input')
-rwxr-xr-xtests/pcre-invalid-utf8-input31
1 files changed, 31 insertions, 0 deletions
diff --git a/tests/pcre-invalid-utf8-input b/tests/pcre-invalid-utf8-input
new file mode 100755
index 0000000..fec23ae
--- /dev/null
+++ b/tests/pcre-invalid-utf8-input
@@ -0,0 +1,31 @@
+#! /bin/sh
+# Ensure that grep -P doesn't abort for invalid multi-byte input
+#
+# Copyright (C) 2013-2016 Free Software Foundation, Inc.
+#
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+require_timeout_
+require_en_utf8_locale_
+require_compiled_in_MB_support
+LC_ALL=en_US.UTF-8 require_pcre_
+
+fail=0
+
+printf 'j\202j\nj\nk\202\n' > in || framework_failure_
+
+LC_ALL=en_US.UTF-8 timeout 3 grep -P j in
+test $? -eq 0 || fail=1
+
+LC_ALL=en_US.UTF-8 timeout 3 grep -P 'k$' in
+test $? -eq 1 || fail=1
+
+echo k >exp
+
+LC_ALL=en_US.UTF-8 timeout 3 grep -aoP 'k*' in >out || fail=1
+compare exp out || fail=1
+
+Exit $fail